/*
* fplot.c
*/

#include <stdio.h>
#include <string.h>
#include <math.h>
#include "fplot.h"

/************************************************************************
*
* ǥХåΤˡɤ plot 饤֥ꥣؿ򥳡뤹뤫
*
************************************************************************/

#ifdef	DEBUG
static void openpl(void)
{ fprintf(stderr, "openpl()\n"); }
static void closepl(void)
{ fprintf(stderr, "closepl()\n"); }
static void erase(void)
{ fprintf(stderr, "erase()\n"); }
static void space(short int x1, short int y1, short int x2, short int y2)
{ fprintf(stderr, "space(%d,%d,%d,%d)\n", x1,y1,x2,y2); }
static void line(short int x1, short int y1, short int x2, short int y2)
{ fprintf(stderr, "line(%d,%d,%d,%d)\n", x1,y1,x2,y2); }
static void circle(short int x, short int y, short int r)
{ fprintf(stderr, "circle(%d,%d,%d)\n", x,y,r); }
static void arc(short int x, short int y,
                short int x1, short int y1, short int x2, short int y2)
{ fprintf(stderr, "arc(%d,%d,%d,%d,%d,%d)\n", x,y,x1,y1,x2,y2); }
static void move(short int x, short int y)
{ fprintf(stderr, "move(%d,%d)\n", x,y); }
static void cont(short int x, short int y)
{ fprintf(stderr, "cont(%d,%d)\n", x,y); }
static void point(short int x, short int y)
{ fprintf(stderr, "point(%d,%d)\n", x,y); }
static void label(char *s)
{ fprintf(stderr, "label(\"%s\")\n", s); }
static void linemod(char *s)
{ fprintf(stderr, "linemod(\"%s\")\n", s); }
#endif

/* ******************************************************** *
*	Fortran interface to plot(3X)
* ******************************************************** */

/* Fortran  plot 饤֥ꥣؿ */
/*
*  void openpl_();
*  void closepl_();
*  void erase_();
*  void space_(int x1, int y1, int x2, int y2);
*  void line_(int x1, int y1, int x2, int y2);
*  void circle_(int x, int y, int r);
*  void arc_(int x, int y, int x1, int y1, int x2, int y2);
*  void move_(int x, int y);
*  void cont_(int x, int y);
*  void point_(int x, int y);
*  void label_(char *s);
*  void linemod_(char *s);
*/

void openpl_(void)  { openpl(); }
void closepl_(void) { closepl(); }
void erase_(void)   { erase(); }
void space_(int *x1, int *y1, int *x2, int *y2)
{ space(*x1, *y1, *x2, *y2); }
void line_(int *x1, int *y1, int *x2, int *y2)
{ line(*x1, *y1, *x2, *y2); }
void circle_(int *x, int *y, int *r)
{ circle(*x, *y, *r); }
void arc_(int *x, int *y, int *x1, int *y1, int *x2, int *y2)
{ arc(*x, *y, *x1, *y1, *x2, *y2); }
void move_(int *x, int *y)
{ move(*x, *y); }
void cont_(int *x, int *y)
{ cont(*x, *y); }
void point_(int *x, int *y)
{ point(*x, *y); }

void label_(char *s, int len)
{
    char s2[100];
    strncpy(s2, s, sizeof(s2));
    if (len >= sizeof(s2))
	s2[sizeof(s2) - 1] = '\0';
    else
	s2[len] = '\0';
    label(s2);
}

void linemod_(char *s)
{ linemod(s); }

/* ******************************************************** *
*	C interface by floating point numbers
* ******************************************************** */

/* ͤϡplot2ps ǤϥޥåʥСǤ롣ѹݤդޤ礦
Ĥޤꡢlow byte 褫high byte 褫ҥ塼ꥹƥå˥å
ͤǤ롣 */

#define	XWIDTH	4096
#define	YWIDTH	4096

static double ratio = 1.0;
static double ratiox = 1.0;
static double ratioy = 1.0;

static double X0 = 0.0, Y0 = 0.0;

typedef struct {
  double x1, y1, x2, y2;
} rectangle;

/* ɺɸưˢɸ */
static int corx(double x) { return rint((x - X0) * ratiox); }
static int cory(double y) { return rint((y - Y0) * ratioy); }

/* ɸˢ ɺɸư */
double invcorx(int x) { return X0 + (double)x / ratiox; }
double invcory(int y) { return Y0 + (double)y / ratioy; }

void fspace(double x1, double y1, double x2, double y2)
{
    double dx, dy;
    space(0, 0, XWIDTH, YWIDTH);
    dx = x2 - x1;
    dy = y2 - y1;
    if (dx > dy) {
	X0 = x1; Y0 = y1 - (dx - dy) / 2;
	ratio = XWIDTH / dx;
    }
    else {
	X0 = x1 - (dy - dx) / 2; Y0 = y1;
	ratio = YWIDTH / dy;
    }
    ratiox = ratioy = ratio;
}

void fspace2(double x1, double y1, double x2, double y2)
{
    space(0, 0, XWIDTH, YWIDTH);
    X0 = x1; Y0 = y1;
    ratiox = XWIDTH / (x2 - x1);
    ratioy = YWIDTH / (y2 - y1);
    ratio = ratiox;
}

void dspace(double x1, double y1, double x2, double y2)
{ fspace(x1, y1, x2, y2); }
void dspace2(double x1, double y1, double x2, double y2)
{ fspace2(x1, y1, x2, y2); }

void fline(double x1, double y1, double x2, double y2)
{ line(corx(x1), cory(y1), corx(x2), cory(y2)); }
void dline(double x1, double y1, double x2, double y2)
{ line(corx(x1), cory(y1), corx(x2), cory(y2)); }

#ifdef	OLD
fcircle(x, y, r) double x, y, r;
{ circle(corx(x), cory(y), (int)(ratio * r)); }
dcircle(x, y, r) double x, y, r;
{ circle(corx(x), cory(y), (int)(ratio * r)); }
#else
void fcircle(double x, double y, double r)
{ circle(corx(x), cory(y), (int)(ratiox * r)); }
void dcircle(double x, double y, double r)
{ circle(corx(x), cory(y), (int)(ratiox * r)); }
#endif

void farc(double x, double y, double x1, double y1, double x2, double y2)
{ arc(corx(x), cory(y), corx(x1), cory(y1), corx(x2), cory(y2)); }
void darc(double x, double y, double x1, double y1, double x2, double y2)
{ arc(corx(x), cory(y), corx(x1), cory(y1), corx(x2), cory(y2)); }

void fmove(double x, double y)
{ move(corx(x), cory(y)); }
void dmove(double x, double y)
{ move(corx(x), cory(y)); }

void fcont(double x, double y)
{ cont(corx(x), cory(y)); }
void dcont(double x, double y)
{ cont(corx(x), cory(y)); }

void fpoint(double x, double y)
{ point(corx(x), cory(y)); }
void dpoint(double x, double y)
{ point(corx(x), cory(y)); }

/* ******************************************************** *
 *	Fortran interface by floating point numbers (real*4)
 * ******************************************************** */

void fspace_(float *x1, float *y1, float *x2, float *y2)
{ fspace(*x1, *y1, *x2, *y2); }

void fline_(float *x1, float *y1, float *x2, float *y2)
{ fline(*x1, *y1, *x2, *y2); }

void fcircle_(float *x, float *y, float *r)
{ fcircle(*x, *y, *r); }

void farc_(float *x, float *y, float *x1, float *y1, float *x2, float *y2)
{ farc(*x, *y, *x1, *y1, *x2, *y2); }

void fmove_(float *x, float *y)
{ fmove(*x, *y); }

void fcont_(float *x, float *y)
{ fcont(*x, *y); }

void fpoint_(float *x, float *y)
{ fpoint(*x, *y); }

/* ******************************************************** *
 *	Fortran interface by floating point numbers (real*8)
 * ******************************************************** */

void dspace_(double *x1, double *y1, double *x2, double *y2)
{ fspace(*x1, *y1, *x2, *y2); }

void dline_(double *x1, double *y1, double *x2, double *y2)
{ fline(*x1, *y1, *x2, *y2); }

void dcircle_(double *x, double *y, double *r)
{ fcircle(*x, *y, *r); }

void darc_(double *x, double *y, double *x1, double *y1, double *x2, double *y2)
{ farc(*x, *y, *x1, *y1, *x2, *y2); }

void dmove_(double *x, double *y)
{ fmove(*x, *y); }

void dcont_(double *x, double *y)
{ fcont(*x, *y); }

void dpoint_(double *x, double *y)
{ fpoint(*x, *y); }

/******************************************************************
 *	Fortran interface (fspace2, dspace2)
 ******************************************************************/

void fspace2_(float *x1, float *y1, float *x2, float *y2)
{ fspace2(*x1, *y1, *x2, *y2); }

void dspace2_(double *x1, double *y1, double *x2, double *y2)
{ fspace2(*x1, *y1, *x2, *y2); }

/******************************************************************
 *
 * ʰץޡ¸ʤ plot(3) Ȥϲδطʤ
 *
 ******************************************************************/

#define	DX	(XWIDTH	/ 100)
#define	DY	(YWIDTH / 100)

void mark(int x, int y)
{ line(x-DX,y-DY,x+DX,y+DY); line(x-DX,y+DY,x+DX,y-DY); move(x,y); }
void mark_(int *x, int *y) { mark(*x,*y); }
void fmark(double x, double y) { mark(corx(x), cory(y)); }
void fmark_(float *x, float *y) { fmark(*x,*y); }
void dmark_(double *x, double *y) { fmark(*x,*y); }
