/*
 * hilbert.c - draw hilbert curves
 * written by Itera Terada
 */

#include <stdio.h>
#include <stdlib.h>
#include "fplot.h"

int x, y;

void step(int dir)
{
    switch (dir%4) {
    case 0:          cont(++x,   y); break;
    case 1: case -3: cont(  x, ++y); break;
    case 2: case -2: cont(--x,   y); break;
    case 3: case -1: cont(  x, --y); break;
    }
}

void hilbert(int deg, int dir, int ori)
{
    if (deg > 0) {
        hilbert(deg - 1, dir - ori, -ori);
        step(dir - ori);
        hilbert(deg - 1, dir, ori);
        step(dir);
        hilbert(deg - 1, dir, ori);
        step(dir + ori);
        hilbert(deg - 1, dir + ori, -ori);
    }
}

#ifdef __CYGWIN__
int main()
#else
int main(int argc, char **argv)
#endif
{
    int deg, wid;

#ifndef __CYGWIN__
    if (argc > 1)
        deg = atoi(argv[1]);
    else
#endif
        printf("input a degree (<= 8): "); scanf("%d", &deg);

    openpl();
    erase();
    wid = 1 << deg;
    space(0, 0, wid + 1, wid + 1);
    move(1, wid);
    x = 1; y = wid;
    hilbert(deg, 3, -1);
    closepl();
    return 0;
}
