/*
 * koch.c
 */

#include <math.h>
#include "fplot.h"

#define DEFAULT 6
#define PI 3.141592653589793
#define DMAX 0.01

unsigned int i;
double d, cos_tbl[6], sin_tbl[6];
double x=0.0, y=0.0;

void koch(void);

int main()
{
        openpl();
        erase();
        fspace(0.0, -1.0, 2.0, 1.0);
	for(i = 0; i < 6; i++) {
	   cos_tbl[i] = cos(i * PI / 3.0);
	   sin_tbl[i] = sin(i * PI / 3.0);
	}
        fmove(0.0, 0.0);
        d = 2; i = 0; koch();
	mkplot("koch.plot");
        closepl();
	return 0;
}

void koch(void)
{
        if (d <= DMAX) {
                fcont(x += d * cos_tbl[i % 6], y += d * sin_tbl[i % 6]);
	}
	else {
                d /= 3; koch(); i++; koch();
                i += 4; koch(); i++; koch();
		d *= 3;
        }
}
